clear all;
close all;

global SMscale;
SMscale=15;
global SMstep;
SMstep = 0.5;

%X = importdata('/Users/galoosli/Recherche/Data/dfki-artificial-3000-unsupervised-ad.csv');
%X = importdata('/Users/galoosli/Recherche/Data/uci-breast-cancer-unsupervised-ad.csv');
%y = X(:,end);
%x = X(:,1:end-1);
%X = importdata('/Users/galoosli/Recherche/Data/pen-local-unsupervised-ad.csv');
%y = X(1:500,1);
%x = X(1:500,2:end);

X = importdata('/Users/galoosli/Recherche/Data/pen-global-unsupervised-ad.csv');
y = X(:,1);
x = X(:,2:end);

%x = normc(x);
x = normalizemeanstd(x);

LA = [0 0.01 0.1 0.3];

nu = [0.05 0.1 0.2];
ker = [ 0.1 0.5 1 2 5 10 20 50 100];
ker2 = [[4 1];[3 1];[2 1];[1 1];];

xaa = x(y==1,:)';
yaa = y(y==1);

tailles = [3 4 5 7 10  20 50 100  200]

for tt = 1:length(tailles)

for loop=1:10
    
    napp = tailles(tt);
    rn = randperm(length(yaa));
    xa = [xaa(:,rn(1:napp))];
    ya = ones(size(xa,2),1);
    xt = [xaa(:,rn(napp+1:end)),x(y==-1,:)'];
    yt = [ones(size(xt,2),1)];
    yt(end:-1:end-length(find(y==-1))) = -1;
    
    SD = simpleMKLData(xa,ya);
    SD.kernelType = {{'rbf','all'},{'poly','all'}};%,{'rbf','single'},{'poly','single'}};
    SD.kernelParam = { ker',ker2};%, ker', ker2 };
    
    for ll = 1:length(LA)
        for p=1:length(nu)
            SM = simpleMKLModelSVDD(SD,1/(nu(p)*length(ya)));
            SM.lambda = LA(ll) ;
            SM.train;
            [ypred,perf(ll,p)] = SM.test(xt,yt);
            
            etal = [sort(ypred(yt==-1));max(ypred(yt==-1))+1;];
            
            %etal = linspace(min(ypred),max(ypred),100);
            for i=1:length(etal)
                yc = ypred-etal(i);
                tp(i) = length(find(yc(yt==1)>0))/length(find(yt==1));
                fp(i) = length(find(yc(yt==-1)>0))/length(find(yt==-1));
            end
            %plot(fp,tp,'+r-'); hold on;
            tmp1 = fp(2:end)-fp(1:end-1);
            auc1(ll,p) = sum(tp(1:end-1).*abs(tmp1));
            
            
            SM2 = simpleMKLModelOCSVM(SD,1/(nu(p)*length(ya)));
            SM2.lambda = LA(ll) ;
            SM2.train;
            [ypred,perf2(ll,p)] = SM2.test(xt,yt);
            
            etal = [sort(ypred(yt==-1)),max(ypred(yt==-1))+1];
            %etal = linspace(min(ypred),max(ypred),100);
            for i=1:length(etal)
                yc = ypred-etal(i);
                tp2(i) = length(find(yc(yt==1)>0))/length(find(yt==1));
                fp2(i) = length(find(yc(yt==-1)>0))/length(find(yt==-1));
            end
            %plot(fp2,tp2,'b.-');
            tmp2 = fp2(2:end)-fp2(1:end-1);
            auc2(ll,p) = sum(tp2(1:end-1).*abs(tmp2));
            drawnow
        end
    end
    
    
    avNu1(loop,:) = max(auc1,[],1);
    avLA1(loop,:) = max(auc1,[],2)
    avNu2(loop,:) = max(auc2,[],1);
    avLA2(loop,:) = max(auc2,[],2)
    
end

mean(avNu1,1);
mean(avLA1,1);
mean(avNu2,1);
mean(avLA2,1);

bestAuc1(tt) = mean(max(avLA1(:,2:end),[],2)) % Slim-MK-SVDD
bestAuc2(tt) = mean(max(avLA2(:,2:end),[],2)) % Slim-MK-OCSVM
bestAuc1n(tt) = mean(avLA1(:,1))% MK-SVDD
bestAuc2n(tt) = mean(avLA2(:,1)) % MK-OCSVM

end

figure;
plot(tailles,bestAuc1,'r');
hold on;
plot(tailles,bestAuc2,'b');
plot(tailles,bestAuc1n,'r--');
plot(tailles,bestAuc2n,'b--');

