% test
clear all;
n=1000;
d=2;
napp=30;
nval=100;

LA = 0.5;

for loop=1
    
    x = rand(d,n);
    y = -ones(n,1);
    points = abs(0.2*randn(d,5)+0.4);
    for i=1:size(points,2)
        m = diag((x-points(:,i)*ones(1,n))'*(x-points(:,i)*ones(1,n)));
        seuil = 0.04*randn(1);
        y(m<abs(seuil))=1;
    end
      
    % partage des donnes pour le non supervis
    xa = x(:,find(y==1,napp));
    ya = ones(napp,1);
    xv = [x(:,find(y==1,napp+nval))];
    xv(:,1:napp) = [];
    yv = [ones(nval,1)];
    xt = x;
    yt = y;
    
    % validation croise
    
    nu = [0.05 0.1 0.2];
    ker = [0.1 0.5 1 2 5 10 20 50 100];
    ker2 = [[4 1];[3 1];[2 1];[1 1];];
    
    perf = zeros(6,length(nu));
    kerV = zeros(2,length(nu));
    ker2V = zeros(2,length(nu),2);
    
    SD = simpleMKLData(xa,ya);
    SD.kernelType = {{'rbf','all'},{'rbf','single'},{'poly','all'},{'poly','single'}};
    SD.kernelParam = {ker' , ker', ker2, ker2 };
    
    for p=1:length(nu)
        SM = simpleMKLModelSVDD(SD,1/(nu(p)*length(ya)));
        SM.lambda = LA ;
        SM.train;
        [~,perf(1,p)] = SM.test(xv,yv);
        
        SM2 = simpleMKLModelOCSVM(SD,1/(nu(p)*length(ya)));
        SM2.lambda = LA ;
        SM2.train;
        [~,perf(2,p)] = SM2.test(xv,yv);
        
        
        SM3 = simpleMKLModelSVDD(SD,1/(nu(p)*length(ya)));
        SM3.lambda = 0;
        SM3.train;
        [~,perf(3,p)] = SM3.test(xv,yv);
        
        SM4 = simpleMKLModelOCSVM(SD,1/(nu(p)*length(ya)));
        SM4.lambda = 0;
        SM4.train;
        [~,perf(4,p)] = SM4.test(xv,yv);
        
        
        for k=1:length(ker)
            SD2 = simpleData(xa,ya);
            SD2.kernelType = 'rbf';
            SD2.kernelParam = ker(k);
            
            
            SM3 = simpleModelSVDD(SD2,1/(nu(p)*length(ya)));
            SM3.train;
            [~,perfV] = SM3.test(xv,yv);
            if (perfV>perf(5,p))
                perf(5,p) = perfV;
                kerV(1,p) = k;
            end
            
            SM4 = simpleModelOCSVM(SD2,1/(nu(p)*length(ya)));
            SM4.train;
            [~,perfV] = SM4.test(xv,yv);
            if (perfV>perf(6,p))
                perf(6,p) = perfV;
                kerV(2,p) = k;
            end
            
        end
        
        for k=1:size(ker2,1)
            SD2 = simpleData(xa,ya);
            SD2.kernelType = 'poly';
            SD2.kernelParam = ker2(k,:);
            
            
            SM3 = simpleModelSVDD(SD2,1/(nu(p)*length(ya)));
            SM3.train;
            [~,perfV] = SM3.test(xv,yv);
            if (perfV>perf(5,p))
                perf(5,p) = perfV;
                kerV(1,p) = length(ker)+k;
            end
            
            SM4 = simpleModelOCSVM(SD2,1/(nu(p)*length(ya)));
            SM4.train;
            [~,perfV] = SM4.test(xv,yv);
            if (perfV>perf(6,p))
                perf(6,p) = perfV;
                kerV(2,p) = length(ker)+k;
            end
            
        end
        
    end
    
    [bestP,indb] = max(perf,[],2)
    
    global SMscale;
    global SMstep;
    SMscale =1;
    SMstep = 0.05;
    
    SM = simpleMKLModelSVDD(SD,1/(nu(indb(1))*length(ya)));
    SM.lambda = LA ;
    SM.train;
    [~,perfTest(1,loop)] = SM.test(xt,yt);
    subplot(3,2,1);
    SM.print2D();
    plot(xt(1,yt==1),xt(2,yt==1),'r.','markersize',4);
    plot(xt(1,yt==-1),xt(2,yt==-1),'g.','markersize',4);
    hold off;
    title('Slim-MK-SVDD');
    axis([0 1 0 1]);
    
    
    SM2 = simpleMKLModelOCSVM(SD,1/(nu(indb(2))*length(ya)));
    SM2.lambda = LA ;
    SM2.train;
    [~,perfTest(2,loop)] = SM2.test(xt,yt);
    subplot(3,2,2);
    SM2.print2D();
    plot(xt(1,yt==1),xt(2,yt==1),'r.','markersize',4);
    plot(xt(1,yt==-1),xt(2,yt==-1),'g.','markersize',4);
    hold off;
    title('Slim-MK-OneClass');
    axis([0 1 0 1]);
    
    
    SM = simpleMKLModelSVDD(SD,1/(nu(indb(3))*length(ya)));
    SM.lambda = 0;
    SM.clear;
    SM.train;
    [~,perfTest(3,loop)] = SM.test(xt,yt);
    subplot(3,2,3);
    SM.print2D();
    plot(xt(1,yt==1),xt(2,yt==1),'r.','markersize',4);
    plot(xt(1,yt==-1),xt(2,yt==-1),'g.','markersize',4);
    hold off;
    title('MK-SVDD');
    axis([0 1 0 1]);
    
    SM2 = simpleMKLModelOCSVM(SD,1/(nu(indb(4))*length(ya)));
    SM2.lambda = 0;
    SM2.clear;
    SM2.train;
    [~,perfTest(4,loop)] = SM2.test(xt,yt);
    subplot(3,2,4);
    SM2.print2D();
    plot(xt(1,yt==1),xt(2,yt==1),'r.','markersize',4);
    plot(xt(1,yt==-1),xt(2,yt==-1),'g.','markersize',4);
    hold off;
    title('MK-OneClass');
    axis([0 1 0 1]);
    
    
    if (kerV(1,indb(5))<=length(ker))
        
        SD2 = simpleData(xa,ya);
        SD2.kernelType = 'rbf';
        SD2.kernelParam = ker(indb(5));
        SM3 = simpleModelSVDD(SD2,1/(nu(indb(5))*length(ya)));
        SM3.train;
        [~,perfTest(5,loop)] = SM3.test(xt,yt);
        subplot(3,2,5);
        SM3.print2D();
        plot(xt(1,yt==1),xt(2,yt==1),'r.','markersize',4);
        plot(xt(1,yt==-1),xt(2,yt==-1),'g.','markersize',4);
        hold off;
        title('SVDD');
        axis([0 1 0 1]);
    else
        
        SD2 = simpleData(xa,ya);
        SD2.kernelType = 'poly';
        SD2.kernelParam = ker2(indb(5),:);
        SM3 = simpleModelSVDD(SD2,1/(nu(indb(5))*length(ya)));
        SM3.train;
        [~,perfTest(5,loop)] = SM3.test(xt,yt);
        subplot(3,2,5);
        SM3.print2D();
        plot(xt(1,yt==1),xt(2,yt==1),'r.','markersize',4);
        plot(xt(1,yt==-1),xt(2,yt==-1),'g.','markersize',4);
        hold off;
        title('SVDD');
        axis([0 1 0 1]);
    end
    
    
    if (kerV(1,indb(6))<=length(ker))
        SD4 = simpleData(xa,ya);
        SD4.kernelType = 'rbf';
        SD4.kernelParam = ker(indb(6));
        SM4 = simpleModelOCSVM(SD4,1/(nu(indb(6))*length(ya)));
        SM4.train;
        [~,perfTest(6,loop)] = SM4.test(xt,yt);
        subplot(3,2,6);
        SM4.print2D();
        plot(xt(1,yt==1),xt(2,yt==1),'r.','markersize',4);
        plot(xt(1,yt==-1),xt(2,yt==-1),'g.','markersize',4);
        hold off;
        title('OneClass');
        axis([0 1 0 1]);
        
    else
        
        
        SD4 = simpleData(xa,ya);
        SD4.kernelType = 'poly';
        SD4.kernelParam = ker2(indb(6),:);
        SM4 = simpleModelOCSVM(SD4,1/(nu(indb(6))*length(ya)));
        SM4.train;
        [~,perfTest(6,loop)] = SM4.test(xt,yt);
        subplot(3,2,6);
        SM4.print2D();
        plot(xt(1,yt==1),xt(2,yt==1),'r.','markersize',4);
        plot(xt(1,yt==-1),xt(2,yt==-1),'g.','markersize',4);
        hold off;
        title('OneClass');
        axis([0 1 0 1]);
        
    end
    
    %[SM.dm' SM2.dm']
    [perfTest(1,loop) perfTest(2,loop) perfTest(3,loop) perfTest(4,loop) perfTest(5,loop) perfTest(6,loop)]
    %[kerV(1,indb(3)) kerV(2,indb(4)) ker2V(1,indb(5),:)' ker2V(2,indb(6),:)']
    
    
    mean(perfTest,2)
    drawnow
end



mean(perfTest,2)


